import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Block  extends Actor
{

    private GreenfootImage[] animation =
    {
        new GreenfootImage("block1.png"),
        new GreenfootImage("block2.png"),
        new GreenfootImage("block3.png"),
        new GreenfootImage("block2.png")
    };
    private int animate = 0;
    private int animationStep = 0;
    private boolean used = false;
    
    public void act() 
    {
        if (used)
        {
            setImage(animation[2]);
        } else {
            if (animationStep++ > 4)
            {
                animationStep = 0;
                setImage(animation[animate++ % 4]);
            }
        }
    }
    
    public void bump(Vector force)
    {
        setLocation(getX() + (int)force.x, getY() + (int)force.y);
        int _x = getX();
        int _y = getY();
        if (!used)
        {
            Game world = (Game)getWorld();
            if (Math.random() > 0.75)
            {
                world.addObject(new PowerUp(new Vector(world.up.direction, 6)), getX(), getY());
                Greenfoot.playSound("Bump.wav");
                used = true;
            } else {
                world.addObject(new Coin(7), _x, _y);
                Greenfoot.playSound("Hit.wav");
            }
        }
    }
}
