import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Bowser  extends People
{

    private int attackNow = 0;
    public int maxAttack = 50;
    public boolean face = Math.random() > 0.5 ? true : false;
    
    private GreenfootImage[] wleft =
    {
        new GreenfootImage("bowserLeft1.png"),
        new GreenfootImage("bowserLeft2.png")
    };
    private GreenfootImage[] wright =
    {
        new GreenfootImage("bowserRight1.png"),
        new GreenfootImage("bowserRight2.png")
    };
    private int animate = 0;
    private int animationStep = 0;
    
    public Bowser() { init();}
    public Bowser(int difficulty)
    {
        maxAttack = difficulty > 5 ? difficulty : 10;
        init();
    }
    
    public void changeFace()
    {
        face = !face;
        updateImage();
    }
    
    private void init()
    {
        speed = 7;
        offset = 30;
        jumpPower = 16;
        fall.max = 16;
        wallBump = 6;
        updateImage();
    }
    
    public void act() 
    {
        climb = 0;
        climbNow = true;
        updateWorld();
        physics();
        if (jumpNow) netForce.add((direction ? right : left));
        animation();
        updateImage();
        direction = platform() ? !direction : direction;
        netForce.updatePosition();
        attack();
        move();
        atEgde();
    }
    
    private void animation()
    {
        if (animationStep++ > 3)
        {
            animate = ++animate % 2;
            animationStep = 0;
        }
    }
    
    private void updateImage()
    {
        setImage(face ? wleft[animate] : wright[animate]);
    }
    
    private void attack()
    {
        if (attackNow++ > maxAttack && jumpNow)
        {
            attackNow = 0;
            fire();
            netForce.add(jumpForce);
            fall.add(jumpForce);
            jumpNow = false;
            jumpSound = true;
            Greenfoot.playSound("BowserJump.wav");
        } else if (!jumpNow && (int)(Math.random() * 10) == 5)
        {
            fire();
        }
    }
    
    private void fire()
    {
        world.addObject(new Fireball(new Vector((face ? left.direction : right.direction), (int)(Math.random() * 5 + 5))), getX(), getY());
        Greenfoot.playSound("BowserAttack.wav");
    }
    
    public void die()
    {
        world.addObject(new Goal(), getX(), getY());
        world.removeObject(this);
    }
}
