import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Brick  extends Actor
{
    public Vector velocity = new Vector(0, 0);  
    private int animate = 0;
    public int animationStep = -1;
    public Brick() {}
    public Brick(Vector movement, int animation)
    {
        velocity = movement;
        animationStep = animation;
        velocity.updatePosition();
    }
    
    public void snap()
    {     
        setLocation(getX() - (getX() % 16), getY() - (getY() % 18));
    }
    
    public void act()
    {
        if (animationStep > 0)
        {
            move();
            turn();
        }
    }
    
    private void move()
    {
        setLocation(getX() + (int)velocity.x, getY() + (int)velocity.y);
    }
    
    private void turn()
    {
        if (animate++ > animationStep || getOneIntersectingObject(Brick.class) != null)
        {
            animate = 0;
            velocity.x *= -1;
            velocity.y *= -1;
        }
    }
}
