import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Coin  extends Actor
{

    public Vector velocity = new Vector(0, 0);
    private Game world;
    
    private GreenfootImage[] animation =
    {
        new GreenfootImage("coin1.png"),
        new GreenfootImage("coin2.png"),
        new GreenfootImage("coin3.png"),
        new GreenfootImage("coin2.png")
    };
    private int animate = 0;
    private int animationStep = 0;
    private int rt;
    private int dn;
    
    public Coin() {};
    public Coin(double splat)
    {
        velocity = new Vector(Math.random() * Math.PI * 2, splat);
    }
    public Coin(Vector toss)
    {
        velocity = toss;
    }
    
    public void act() 
    {
        if (world == null)
        {
            world = (Game)getWorld();
            rt = world.getWidth() - 10;
            dn = world.getHeight() - 10;
        }
        if (animationStep++ > 4)
        {
            animationStep = 0;
            setImage(animation[animate++ % 4]);
        }
        atEdge();
        move();
    }
    
    private void atEdge()
    {
        if (getX() < 10 || getX() > rt) velocity.x *= -1;
        if (getY() < 10 || getY() > dn) velocity.y *= -1;
    }
    
    private void move()
    {
        setLocation(getX() + (int)velocity.x, getY() + (int)velocity.y);
    }
}
