import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Fireball  extends Actor
{
    protected int spin = (int)(Math.random() * -30 - 15);
    public Vector velocity = new Vector(0, 0);
    protected Game world;
    protected int rt;
    protected int dn;
    
    public Fireball() { init(); }
    public Fireball(Vector toss)
    { 
        init();
        velocity = toss;
    }
    protected void init()
    {
        setRotation((int)(Math.random() * 360));
    }
    
    public void act() 
    {
        updateWorld();
        setLocation(getX() + (int)velocity.x, getY() + (int)velocity.y);
        setRotation(getRotation() + spin);
        atEdge();
    }
    
    protected void updateWorld()
    {
        if (world == null)
        {
            world = (Game)getWorld();
            rt = world.getWidth() - 10;
            dn = world.getHeight() - 10;
        }
    }
    
    protected void atEdge()
    {
        if ((getX() < 10 || getX() > rt) ||
            (getY() < 10 || getY() > dn))
                world.removeObject(this);
    }
}
