import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

public class Floor  extends Actor
{
    private int speed = (int)(Math.random() * 6 - 3);
    public int radius = 50;
    private GreenfootImage img;
    
    public Floor() { init(); }
    public Floor(int width)
    {
        init();
        radius = width > 25 ? (width < 150 ? width : 150) : 25;
        img.scale(radius * 6, radius * 6);
    }
    
    private void init()
    {
        img = getImage();
        int amount = (int)(Math.random() * 9 - 2);
        if (amount > 0)
        {
            Color clear = new Color(0, 0, 0, 0);
            img.setColor(clear);
            img.drawRect(-150, -150, 300, 300);
            GreenfootImage[] trees = 
            {
                new GreenfootImage("tree1.png"),
                new GreenfootImage("tree2.png")
            };
            int[] offsets = { 80, 98 };
            double angle = (Math.PI * 2) / amount;
            double myAngle = Math.random() * Math.PI * 2;
            GreenfootImage draw;
            int select;
            for (int i = 0; i < amount; i++)
            {
                select = Math.random() > 0.5 ? 0 : 1;
                draw = new GreenfootImage(trees[select]);
                draw.rotate((int)Math.toDegrees(myAngle + Math.PI / 2));
                img.drawImage(
                    draw,
                    (int)(offsets[select] * Math.cos(myAngle)) + 150 - (int)(draw.getWidth() / 2),
                    (int)(offsets[select] * Math.sin(myAngle)) + 150 - (int)(draw.getHeight() / 2)
                );
                myAngle += angle * (Math.random() * 1.3);
            }
        }
    }
    
    public void act() 
    {
        setRotation(getRotation() + speed);
    }    
}
