import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Goomba  extends People
{

    private Hurt weakpoint = new Hurt(this, 32);
    
    private GreenfootImage[] animation =
    {
        new GreenfootImage("goomba1.png"),
        new GreenfootImage("goomba2.png")
    };
    private int animate = 0;
    private int animationStep = 0;
    
    public Goomba() { init(); }
    public Goomba(boolean turn)
    {
        direction = turn;
        init();
    }
    
    private void init()
    {
        offset = 16;
        speed = 3;
    }
    
    public void act() 
    {
        updateWorld();
        updateWeakpoint();
        physics();
        platform();
        updateAnimation();
        direction = platform() ? !direction : direction;
        netForce.add((direction ? left : right));
        netForce.updatePosition();
        move();
        atEgde();
    }
    
    private void updateWeakpoint()
    {
        if (weakpoint.getWorld() == null) world.addObject(weakpoint, getX(), getY());
    }
    
    private void updateAnimation()
    {
        if (animationStep++ > 3)
        {
            animationStep = 0;
            setImage(animation[(animate++ % 2)]);
        }
    }
}
