import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.io.*;
import java.util.List;
import javax.swing.*;
import javax.swing.SwingUtilities;
import javax.swing.filechooser.*;

public class Helper  extends Actor
{
    private Game world;
    private int orgX;
    private int orgY;
    private boolean layBrick = false;
    
    public Helper(Game parent)
    {
        world = parent;
    }
    
    public void act()
    {
        if (layBrick)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if (mouse != null) setLocation(mouse.getX() - (mouse.getX() % 16), mouse.getY() - (mouse.getY() % 18));
            if (Greenfoot.mousePressed(this))
            {
                if (Greenfoot.isKeyDown("c"))
                    world.addObject(new Coin(), getX(), getY());
                else if (Greenfoot.isKeyDown("m"))
                    world.addObject(new PowerUp(true), getX(), getY());
                else if (Greenfoot.isKeyDown("l"))
                    world.addObject(new PowerUp(false), getX(), getY());
                else if (Greenfoot.isKeyDown("b"))
                    world.addObject(new Block(), getX(), getY());
                else if (Greenfoot.isKeyDown("f"))
                    world.addObject(new Fireball(), getX(), getY());
                else 
                    world.addObject(new Brick(), getX(), getY());
            }
            if (Greenfoot.isKeyDown("enter"))
            {
                setLocation(orgX, orgY);
                layBrick = false;
            }
        }
    }
    
    public void resetSound()
    {
        world.theme.close();
        world.intro = true;
    }
    
    public void buildSceneBricks()
    {
        orgX = getX();
        orgY = getY();
        layBrick = true;
    }
    
    public void snapBricks()
    {
        List bricks = getWorld().getObjects(Brick.class);
        Brick brick;
        for (int i = 0 ; i < bricks.size(); i++)
        {
            brick = (Brick)bricks.get(i);
            brick.snap();
        }
    }
    
    public void changeGravity(Vector gravity)
    {
        world.gravity = gravity;
        world.up = new Vector(gravity.direction + Math.PI, gravity.magnitude);
    }
    
    public void saveScene()
    {
        int returnVal = world.fileLoader.showSaveDialog(world.panelHandler);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            world.file = world.fileLoader.getSelectedFile();
            world.save();
        }
    }
    
    public void openScene()
    {
        if (world.open()) world.load();
    }
}
