import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Koopa extends People
{
    private GreenfootImage[] wleft =
    {
        new GreenfootImage("koopaLeft1.png"),
        new GreenfootImage("koopaLeft2.png")
    };
    private GreenfootImage[] wright =
    {
        new GreenfootImage("koopaRight1.png"),
        new GreenfootImage("koopaRight2.png")
    };
    private int animate = 0;
    private int animationStep = 0;
    
    private Hurt weakpoint = new Hurt(this, 30);
    public boolean dead = false;
    private int undead = 0;
    public int lives = (int)(Math.random() * 500 + 100);
    
    public Koopa() { init(); }
    public Koopa(boolean turn)
    {
        direction = turn;
        init();
    }
    
    private void init()
    {
        speed = 3;
        offset = 22;
        updateImage();
    }
    
    private void animation()
    {
        if (animationStep++ > 3)
        {
            animate = ++animate % 2;
            animationStep = 0;
        }
    }
    
    public void updateImage()
    {
        setImage(direction ? wleft[animate] : wright[animate]);
    }
    
    public void act() 
    {
        updateWorld();
        updateWeakpoint();
        physics();
        if (!dead) netForce.add((direction ? left : right));
        direction = platform() ? !direction : direction;  
        updateImage();
        netForce.updatePosition();
        move();
        atEgde();
        revive();
        animation();
    }
    
    private void revive()
    {
        if (dead)
        {
            setImage("koopaDead.png");
            undead++;
            offset = 16;
            lives--;
            if (undead > 150) setImage("koopaUndead.png");
        }
        if (undead > (int)(Math.random() * 300 + 150))
        {
            offset = 22;
            undead = 0;
            dead = false;
            updateImage();
            speed++;
        }
    }
    
    private void updateWeakpoint()
    {
        if (weakpoint.getWorld() == null) world.addObject(weakpoint, getX(), getY());
    }
}
