import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class PowerUp  extends Actor
{

    private Vector velocity = new Vector(0, 0);
    private int used = 1000;
    private boolean decay = true;
    public boolean type = Math.random() > 0.5 ? true : false;
    
    public PowerUp() { changeImage(); }
    public PowerUp(Vector toss)
    {
        velocity = toss;
        changeImage();
    }
    public PowerUp(boolean powerType)
    {
        type = powerType;
        decay = false;
        changeImage();
    }
    
    public void changeType()
    {
        type = !type;
        changeImage();
    }
    
    private void changeImage()
    {
        setImage(new GreenfootImage((type ? "mushroom.png" : "flower.png")));
    }
    
    public void act() 
    {
        atEdge();
        move();
        if (decay) decayAway();
    }
    
    private void decayAway()
    {
        if (used-- < 0)
        {
            getWorld().removeObject(this);
        }
    }
    
    private void atEdge()
    {
        if (getX() < 10 || getX() > getWorld().getWidth() - 10) velocity.x *= -1;
        if (getY() < 10 || getY() > getWorld().getHeight() - 10) velocity.y *= -1;
    }
    
    private void move()
    {
        setLocation(getX() + (int)velocity.x, getY() + (int)velocity.y);
    }
}
