import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class SuperYoshi  extends Actor
{
    private Mario protect;
    private Game world;
    
    private int flash = 0;
    private int timer = 1800;
    private boolean visible = false;
    
    public SuperYoshi(Mario player, Game parent)
    {
        world = parent;
        protect = player;
        Greenfoot.delay(70);
        protect.setImage(protect.lastImage);
        world.theme.stop();
        world.theme.close();
        world.theme.open("SuperYoshi.wav");
        world.theme.setLoops(1);
        world.theme.play();
        world.invincible = true;
    }
    
    public void act() 
    {
        if (protect.getWorld() != null)
        {
            move();
            kill();
            timeOut();
        } else world.removeObject(this);
    }
    
    private void timeOut()
    {
        if (timer-- < 0)
        {
            if (flash++ > 6)
            {
                flash = 0;
                getImage().setTransparency((visible ? 255 : 0));
                visible = !visible;
            }
            if (!world.invincible)
            {
                world.removeObject(this);
            }
        }
    }
    
    private void kill()
    {
        Bowser boss = (Bowser)getOneIntersectingObject(Bowser.class);
        if (boss != null)
        {
            world.addObject(new Coin(Math.random() * 7), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 6), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 5), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 4), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 4), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 3), boss.getX(), boss.getY());
            world.addObject(new Coin(Math.random() * 3), boss.getX(), boss.getY());
            world.removeObject(boss);
            Greenfoot.playSound("Hit.wav");
        }
        
        Koopa koopa = (Koopa)getOneIntersectingObject(Koopa.class);
        if (koopa != null)
        {
            world.addObject(new Coin(Math.random() * 5), koopa.getX(), koopa.getY());
            world.addObject(new Coin(Math.random() * 4), koopa.getX(), koopa.getY());
            world.addObject(new Coin(Math.random() * 3), koopa.getX(), koopa.getY());
            world.addObject(new Coin(Math.random() * 3), koopa.getX(), koopa.getY());
            world.removeObject(koopa);
            Greenfoot.playSound("Hit.wav");
        }
        
        Goomba goomba = (Goomba)getOneIntersectingObject(Goomba.class);
        if (goomba != null)
        {
            world.addObject(new Coin(Math.random() * 5), goomba.getX(), goomba.getY());
            world.addObject(new Coin(Math.random() * 3), goomba.getX(), goomba.getY());
            world.removeObject(goomba);
            Greenfoot.playSound("Hit.wav");
        }
        
        Plant plant = (Plant)getOneIntersectingObject(Plant.class);
        if (plant != null)
        {
            world.addObject(new Coin(Math.random() * 3), plant.getX(), plant.getY());
            world.removeObject(plant);
            Greenfoot.playSound("Hit.wav");
        }
        
        if (timer > 0)
        {
            Fireball fireball = (Fireball)getOneIntersectingObject(Fireball.class);
            if (fireball != null)
            {
                world.addObject(new Coin(Math.random() * 5), fireball.getX(), fireball.getY());
                world.removeObject(fireball);
                Greenfoot.playSound("Hit.wav");
            }
        }
    }
    
    private void move()
    {
        setLocation(protect.getX(), protect.getY());
    }
}
