import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class YourFireball  extends Fireball
{
    public YourFireball()
    {
        init();
        velocity = new Vector(Math.random() * Math.PI * 2, Math.random() * 10 + 2);
    }
    
    public void act() 
    {
        updateWorld();
        setLocation(getX() + (int)velocity.x, getY() + (int)velocity.y);
        setRotation(getRotation() + spin);
        hitEnemies();
        atEdge();
    }
    
    private void hitEnemies()
    {
        int _x, _y;
        
        Koopa koopa = (Koopa)getOneIntersectingObject(Koopa.class);
        if (koopa != null)
        {
            _x = koopa.getX();
            _y = koopa.getY();
            world.addObject(new Coin(Math.random() * 5), _x, _y);
            world.addObject(new Coin(Math.random() * 4), _x, _y);
            world.addObject(new Coin(Math.random() * 3), _x, _y);
            world.addObject(new Coin(Math.random() * 3), _x, _y);
            world.removeObject(koopa);
            world.addObject(new YourFireball(), getX(), getY());
            Greenfoot.playSound("Fireball.wav");
        }
        
        Goomba goomba = (Goomba)getOneIntersectingObject(Goomba.class);
        if (goomba != null)
        {
            _x = goomba.getX();
            _y = goomba.getY();
            world.addObject(new Coin(Math.random() * 5), _x, _y);
            world.addObject(new Coin(Math.random() * 3), _x, _y);
            world.removeObject(goomba);
            world.addObject(new YourFireball(), getX(), getY());
            Greenfoot.playSound("Fireball.wav");
        }
        
        Plant plant = (Plant)getOneIntersectingObject(Plant.class);
        if (plant != null)
        {
            world.addObject(new Coin(Math.random() * 3), plant.getX(), plant.getY());
            world.removeObject(plant);
            world.addObject(new YourFireball(), getX(), getY());
            Greenfoot.playSound("Fireball.wav");
        }
    }
}
